## dh-python 6.20230825

=== tests/tpb01/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control

clean:
	./debian/rules clean

=== tests/tpb07/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test -f debian/python3-bar/usr/lib/python3/dist-packages/bar/__init__.py
	test -f debian/python3-foo/usr/bin/foo
	test -f debian/python3-bar/usr/bin/bar
	test -e foo/tests-executed-foo
	test -e .pybuild/cpython3_3.11_bar/build/tests-executed-bar

clean:
	./debian/rules clean

=== debian/changelog ===
dh-python (6.20230825) unstable; urgency=medium

  * Parse .egg-info/PKG-INFO for Requirements. distutils-extra has been using
    these for a while now. (Closes: #1050305)
  * Fix some details in python3-supported-min/max generation. Thanks Jochen
    Sprickerhof for noticing and sending an MR.
  * Remove *.egg-info directories in clean step, as part of Debian's wider
    effort to improve clean targets. Thanks Stuart Prescott for the patch.
  * Explain that setting pybuild.testfiles overrides the defaults in
    pybuild(1). (Closes: #1042802)

 -- Stefano Rivera <stefanor@debian.org>  Fri, 25 Aug 2023 22:51:08 +0200

dh-python (6.20230813) unstable; urgency=medium

  * When we build a wheel for tox, with the distutils plugin, make sure
    our .pydistutils.cfg isn't present, so we build it in the standard layout.
  * Remove RECORD files from dist-info, these are incompatible with
    multi-arch.
  * Support for backporting the pyproject plugin to Python < 3.11. Thanks
    Stuart Prescott. (Closes: #1043301)
  * Use values for _PYTHON_HOST_PLATFORM that are closer to Python's defaults.
  * tox: Pass -x testenv.passenv+=_PYTHON_HOST_PLATFORM, so that pip will
    accept the _PYTHON_HOST_PLATFORM that the test wheel was built with.
  * Generate dependencies on using python3-supported-min and
    python3-supported-max.  Allowing dependencies to work correctly on all
    supported python 3 versions.  (Closes: #1028603)
  * pybuild-auto-pkgtest: Run tox tests against the installed package.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 13 Aug 2023 00:58:58 +0200

dh-python (6.20230802) unstable; urgency=medium

  * Add pybuild plugin to build meson packages.
  * Update pydist fallback.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 02 Aug 2023 11:05:40 +0200

dh-python (6.20230603) experimental; urgency=medium

  * Bump major version, post-bookworm.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 03 Jun 2023 10:50:19 -0400

dh-python (5.20230510) experimental; urgency=medium

  * Add support for PEP440 standards-markers in PyDist files (which superseded
    PEP386 almost a decade ago).
  * Add support for tox 4. Avoid needing to do an isolated build of the
    package by using the wheel we built, ourselves. (Closes: #1035675)
    - Packages using the distutils plugin now need python3-wheel installed.
      Raise an error explaining that wheel is needed, if it's missing.
    - Support all 3 potential tox configuration files. (Closes: #1033486)
  * dh_python3: Write a "debian" INSTALLER file into dist-info directories.
    (Closes: #1032133)
  * Use tomllib (available since Python 3.11) instead of tomli.
    (Closes: #1032866)
  * Use cachy as an example dependency instead of tomli, in tests.
  * Add pyproject.toml and pytest.ini to the default testfiles.
    (Closes: #1031609)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 10 May 2023 19:26:51 -0400

=== debian/control ===
Source: dh-python
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Uploaders:
 Stefano Rivera <stefanor@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libdpkg-perl,
 libpython3-stdlib,
 python3-all <!nocheck>,
 python3-all-dbg <!nocheck>,
 python3-all-dev <!nocheck>,
 python3-docutils <!nodoc>,
 python3-minimal,
 python3-nose2 <!nocheck>,
Standards-Version: 4.6.2
Vcs-Git: https://salsa.debian.org/python-team/tools/dh-python.git
Vcs-Browser: https://salsa.debian.org/python-team/tools/dh-python
Rules-Requires-Root: no

Package: dh-python
Architecture: all
Multi-Arch: foreign
Depends:
# depend on distutils to avoid adding it to Build-Depends in other packages
 python3-distutils | python3 (<< 3.6.5~rc1-1),
 ${misc:Depends},
 ${python3:Depends},
Provides:
 dh-sequence-python3,
Suggests:
 dpkg-dev,
 flit,
 libdpkg-perl,
 python3-build,
 python3-installer,
 python3-wheel,
Breaks:
# due to /usr/bin/dh_python3 and debhelper files
 python3 (<< 3.3.2-4~),
Description: Debian helper tools for packaging Python libraries and applications
 This package contains:
  * pybuild - invokes various build systems for requested Python versions in
    order to build modules and extensions
  * dh_python3 - calculates Python 3.X dependencies for Debian packages,
    adds maintainer scripts to byte compile files, etc.

Package: pybuild-plugin-pyproject
Architecture: all
Multi-Arch: foreign
Depends:
 dh-python (= ${source:Version}),
 python3-build (>> 0.7~),
 python3 (>> 3.11~) | python3-tomli,
 python3-installer,
 ${misc:Depends},
Description: Debian helper tools for packaging Python libraries using PEP517
 This metapackage depends on the components necessary for building packages
 with the generic PEP517 build plugin.

Package: pybuild-plugin-autopkgtest
Architecture: all
Multi-Arch: foreign
Depends:
 debhelper,
 dh-python (= ${source:Version}),
 make,
 ${misc:Depends},
Description: pybuild autopkgtest test runner (metapackage)
 This package depends on the packages required to run pybuild-autopkgtest, a
 pybuild-based autopkgtest test runner. pybuild-autopkgtest will run the same
 test suite that regular pybuild runs during build time, but against the
 installed packages and without doing a build first.

=== tests/tpb07/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild -d foo --build --verbose --name=foo
	../../pybuild -d bar --build --verbose --name=bar

override_dh_auto_install:
	../../pybuild -d foo --install --name=foo
	../../pybuild -d bar --install --name=bar

override_dh_auto_test:
	../../pybuild -d foo --test --name=foo --test-tox --test-args=-v
	../../pybuild -d bar --test --name=bar --test-pytest -v

override_dh_auto_clean:
	../../pybuild -d foo --clean --verbose --name=foo
	../../pybuild -d bar --clean --verbose --name=bar
	rm -rf .pybuild foo/foo.egg-info bar/bar.egg-info foo/.tox foo/tests-executed-foo

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== debian/tests/control ===
Tests: dh-python
Depends:
 build-essential,
 debhelper,
 dh-python,
 fakeroot,
 libjs-jquery,
 python3-all-dbg,
 python3-all-dev,
Restrictions: allow-stderr

Tests: nosetests
Depends:
 dh-python,
 flit,
 python3-all,
 python3-all-dbg,
 python3-nose2,
Restrictions: allow-stderr

Tests: pybuild
Depends:
 build-essential,
 debhelper,
 dh-python,
 fakeroot,
 flit,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-cachy,
 python3-poetry-core,
 python3-pytest,
 python3-setuptools,
 tox (>= 4),
Restrictions: allow-stderr

Tests: pybuild-autopkgtest
Depends:
 autopkgtest,
 debhelper,
 dh-python,
 make,
 pybuild-plugin-pyproject,
 python3-all,
 python3-pytest,
 tox
Restrictions: allow-stderr

=== tests/t307/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Maximilian Engelhardt <maxi@daemonizer.de>
Build-Depends: debhelper (>= 12.9), python3-all-dev:any
Standards-Version: 4.5.1

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: package with python3-all-dev dependency using :any
 example package #6 - private Python extensions and python3-all-dev:any
 dependency

=== tests/ta03/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , pybuild-plugin-pyproject
 , python3-all
 , python3-pytest
 , python3-tox
 , python3-setuptools
Standards-Version: 3.9.4

Package: python3-foo
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #8

=== tests/tpb01/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , python3-all
 , python3-setuptools
 , python3-cachy
# , dh-python
Standards-Version: 3.9.4

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #1

=== tests/tpb04/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , python3-all-dev
 , python3-setuptools
 , python3-cachy
 , tox
# , dh-python
Standards-Version: 3.9.4

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #1

Package: python3-foo-ext
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython extensions
 example package #2

=== tests/tpb07/debian/control ===
Source: foobar
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , python3-all
 , python3-pytest
 , python3-setuptools
 , pybuild-plugin-pyproject
 , tox (>= 4)
Standards-Version: 3.9.4

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #1

Package: python3-bar
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #2

## dh-python 6.20240310~bpo12+1

=== debian/changelog ===
dh-python (6.20240310~bpo12+1) UNRELEASED; urgency=medium

  * bookworm-backports Rebuilt for bookworm.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 18 Mar 2024 16:15:06 +0000

dh-python (6.20240310) unstable; urgency=medium

  [ Jérémy Lal ]
  * Fix pydist path in dh_python3 doc

  [ Louis-Philippe Véronneau ]
  * automatically set env var for python3-poetry-dynamic-versioning

  [ Niels Thykier ]
  * Remove trivially removable code related to cpython << 3.11. This includes
    some cpython2 code.

  [ Stefano Rivera ]
  * Remove hard-coded 3.11 from tests. (Closes: #1064963)
  * Remove flit plugin, replaced by pyproject. (Closes: #1061309)
  * Drop support for PyPy (2.7), long removed from the archive.
  * Improve test cleaning.

 -- Stefano Rivera <stefanor@debian.org>  Sun, 10 Mar 2024 11:41:23 -0400

dh-python (6.20231223) unstable; urgency=medium

  [ Stefano Rivera ]
  * When building PEP-517 packages with the mesonpy backend, pass the same
    options to meson as debhelper would, when building meson packages itself.
    (Closes: #1041692)
  * Handle tab-prefixed debian/control lines in dhpython/debhelper.py,
    correctly. Strip the tab rather than including it in a package name.

  [ Piotr Ożarowski ]
  * pydist fallback: add Cython override to point to cython3 package

 -- Stefano Rivera <stefanor@debian.org>  Sat, 23 Dec 2023 20:06:52 -0400

dh-python (6.20231204) unstable; urgency=medium

  * dh_python3: Fix file filtering bug that left dot-directories in binary
    packages. (Closes: #1056291)
  * Remove dot-files from dist-packages. (See: #1057432)
  * Fix a bug in merging dist-info directories that left INSTALLER files in
    /usr/lib/python3.12/dist-packages.
  * Update pydist fallback.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 04 Dec 2023 21:08:55 -0400

dh-python (6.20231107) unstable; urgency=medium

  * Correct logic for leaving SOURCES.txt when cleaning egg-info, it was
    inverted by mistake.
  * Don't trip over LICENSES directories in .dist-info. (Closes: #1055008)

 -- Stefano Rivera <stefanor@debian.org>  Tue, 07 Nov 2023 17:34:28 +0200

dh-python (6.20231025) unstable; urgency=medium

  * Align detection of nocheck with debhelper, thanks Victor Westerhuis.
  * Remove more license files from dist-info, thanks Christoph Anton Mitterer.
  * Clean .tox directories. Previously the code to do this was unreachable.
    (Closes: #1049950)
  * Add test-coverage for distutils-extra, missed in 6.20230825.
  * pybuild: Ignore an exit code of 5, for no tests found, from
    unittest.discover for now. When we are ready to break packages and fix
    #1024971, this will change.
  * Build-Depends: python3-setuptools to avoid FTBFS with
    Python 3.12 as a supported version.
  * Also, Depends: python3-setuptools for now, to avoid adding it
    in other packages.
  * Don't clean egg-info/SOURCES.txt for packages using setuptools-scm, as
    they may be depending on it to locate package_data. (Closes: #1052854)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 25 Oct 2023 20:08:06 +0200

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,7 @@
  python3-docutils <!nodoc>,
  python3-minimal,
  python3-nose2 <!nocheck>,
+ python3-setuptools,
 Standards-Version: 4.6.2
 Vcs-Git: https://salsa.debian.org/python-team/tools/dh-python.git
 Vcs-Browser: https://salsa.debian.org/python-team/tools/dh-python
@@ -25,6 +26,7 @@
 Depends:
 # depend on distutils to avoid adding it to Build-Depends in other packages
  python3-distutils | python3 (<< 3.6.5~rc1-1),
+ python3-setuptools,
  ${misc:Depends},
  ${python3:Depends},
 Provides:

## dh-python 6.20240401~cloud0

=== tests/t301/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	grep -qe "Depends: .*python3\(:any\)\? (<< 3.9)" debian/python3-foo/DEBIAN/control
	grep -q "Recommends: .*python3-mako" debian/python3-foo/DEBIAN/control
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test ! -f debian/python3-foo/usr/lib/python3/dist-packages/foo/spam.py
	grep -q 'py3compile -p python3-foo -V 3\.1-3\.9' debian/python3-foo/DEBIAN/postinst
	grep -q 'pypy3compile -p python3-foo -V 3\.1-3\.9' debian/python3-foo/DEBIAN/postinst
	grep -q 'py3clean -p python3-foo\s*$$' debian/python3-foo/DEBIAN/prerm
	test ! -f debian/python3-foo/usr/lib/python3/dist-packages/.coverage

clean:
	./debian/rules clean
	rm -rf lib/Foo.egg-info

=== debian/changelog ===
dh-python (6.20240401~cloud0) jammy-caracal; urgency=medium

  * New upstream release for the Ubuntu Cloud Archive.

 -- Openstack Ubuntu Testing Bot <openstack-testing-bot@ubuntu.com>  Tue, 02 Apr 2024 02:42:06 +0000

dh-python (6.20240401) unstable; urgency=medium

  [ Stefano Rivera ]
  * Remove python3-distutils from dh-python Depends. It doesn't exist as a
    package for 3.12, and is provided as a compatibility shim by setuptools.
    (Closes: #1066833)
  * Add support for testing with stestr. Thanks James Page for the patch.
    (Closes: #883004)

  [ Julian Gilbey ]
  * Add python3-flit-scm to list of build-dependencies requiring
    SETUPTOOLS_SCM_PRETEND_VERSION (Closes: #1067822)

 -- Stefano Rivera <stefanor@debian.org>  Mon, 01 Apr 2024 13:23:32 -0400

=== debian/control ===
--- 
+++ 
@@ -24,8 +24,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
-# depend on distutils to avoid adding it to Build-Depends in other packages
- python3-distutils | python3 (<< 3.6.5~rc1-1),
+# depend on setuptools to help packages migrate from distutils. Remove once 3.12 is default
  python3-setuptools,
  ${misc:Depends},
  ${python3:Depends},

=== tests/t302/debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=python_distutils

override_dh_install:
	dh_install
	# install also as private extension
	dh_install debian/python3-foo/usr/local/lib/python3*/dist-packages/foo/bar*.so \
		/usr/lib/python3-foo/
	mkdir -p debian/python3-foo/usr/lib/python3/dist-packages/empty-public-dir
	mkdir -p debian/python3-foo/usr/lib/python3-foo/empty-private-dir
	DH_VERBOSE=1 ../../dh_python3

comma:=,
empty:=
space:= $(empty) $(empty)
PYTHONS=$(subst $(comma),$(space),$(DEBPYTHON3_SUPPORTED))
override_dh_auto_build:
	for ver in $(PYTHONS); do\
	  python$$ver setup.py build; done

override_dh_auto_install:
	for ver in $(PYTHONS); do\
	  python$$ver setup.py install --root=debian/python3-foo;\
	done
	mkdir -p debian/python3-foo/usr/include/python$(DEBPYTHON3_DEFAULT)/
	touch debian/python3-foo/usr/include/python$(DEBPYTHON3_DEFAULT)/foo.h

override_dh_auto_clean:
	rm -rf Foo.egg-info

=== debian/tests/control ===
--- 
+++ 
@@ -31,6 +31,7 @@
  python3-poetry-core,
  python3-pytest,
  python3-setuptools,
+ python3-setuptools-scm,
  tox (>= 4),
 Restrictions: allow-stderr

=== tests/tpb04/debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  , python3-cachy
  , tox
 # , dh-python
+Rules-Requires-Root: no
 Standards-Version: 3.9.4
 
 Package: python3-foo

=== tests/tpb05/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , python3-all
 , python3-poetry-core
 , python3-pytest
 , pybuild-plugin-pyproject
Rules-Requires-Root: no
Standards-Version: 3.9.4

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #1

## dh-python 6.20240401

=== Makefile ===
#!/usr/bin/make -f
INSTALL ?= install
PREFIX ?= /usr/local
MANPAGES ?= pybuild.1 pybuild-autopkgtest.1 dh_python3.1
DVERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: (.+),\1,p' || echo 'DEVEL')
VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p' || echo 'DEVEL')

clean:
	make -C tests clean
	make -C pydist clean
	find . -name '*.py[co]' -delete
	find . -name __pycache__ -type d | xargs rm -rf
	rm -f .coverage $(MANPAGES)
	rm -rf .pybuild

dist:
	git archive --format=tar --prefix=dh-python-$(VERSION)/ HEAD \
	| xz -9 -c >../dh-python_$(VERSION).orig.tar.xz

install:
	$(INSTALL) -m 755 -d $(DESTDIR)$(PREFIX)/bin \
		$(DESTDIR)$(PREFIX)/share/debhelper/autoscripts/ \
		$(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Sequence/ \
		$(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Buildsystem/ \
		$(DESTDIR)$(PREFIX)/share/dh-python/dhpython/build \
		$(DESTDIR)$(PREFIX)/share/dh-python/dist
	$(INSTALL) -m 644 pydist/*_fallback $(DESTDIR)$(PREFIX)/share/dh-python/dist/
	$(INSTALL) -m 644 dhpython/*.py $(DESTDIR)$(PREFIX)/share/dh-python/dhpython/
	$(INSTALL) -m 644 dhpython/build/*.py $(DESTDIR)$(PREFIX)/share/dh-python/dhpython/build/
	$(INSTALL) -m 755 pybuild $(DESTDIR)$(PREFIX)/share/dh-python/
	$(INSTALL) -m 755 pybuild-autopkgtest $(DESTDIR)$(PREFIX)/share/dh-python/
	$(INSTALL) -m 755 dh_python3 $(DESTDIR)$(PREFIX)/share/dh-python/
	sed -i -e 's/DEVELV/$(DVERSION)/' $(DESTDIR)$(PREFIX)/share/dh-python/pybuild
	sed -i -e 's/DEVELV/$(DVERSION)/' $(DESTDIR)$(PREFIX)/share/dh-python/dh_python3
	
	$(INSTALL) -m 644 dh/pybuild.pm $(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Buildsystem/
	$(INSTALL) -m 644 dh/python3.pm $(DESTDIR)$(PREFIX)/share/perl5/Debian/Debhelper/Sequence/
	$(INSTALL) -m 644 autoscripts/* $(DESTDIR)$(PREFIX)/share/debhelper/autoscripts/

%.1: %.rst
	rst2man $< > $@

%.htm: %.rst
	rst2html $< > $@

manpages: $(MANPAGES)

dist_fallback:
	make -C pydist $@

# TESTS
nose:
	#nosetests3 --verbose --with-doctest --with-coverage
	nose2-3 --verbose --plugin nose2.plugins.doctests --with-doctest

tests: nose
	make -C tests

test%:
	make -C tests $@

.PHONY: clean tests test% check_versions

=== tests/tpb02/Makefile ===
#!/usr/bin/make -f
include ../common.mk

DI=debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test -f debian/python3-foo/usr/bin/foo
	test ! -f $(DI)/RECORD
	test ! -f $(DI)/direct_url.json
	grep -q debian debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info/INSTALLER
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control
	grep -q 'Depends:.*python3-importlib-metadata \| python3 (>> 3\.5)' debian/python3-foo/DEBIAN/control
	grep -L 'Depends:.*tox' debian/python3-foo/DEBIAN/control | grep -q control
	find .pybuild -name test-executed | grep -q test-executed
	test -f debian/python3-foo/usr/share/man/man1/foo.1.gz

clean:
	./debian/rules clean

=== tests/tpb04/Makefile ===
#!/usr/bin/make -f
include ../common.mk

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo.py
	test -f debian/python3-foo-ext/usr/lib/python3/dist-packages/_foo.abi3.so
	test -e test-executed

clean:
	./debian/rules clean

=== tests/tpb05/Makefile ===
#!/usr/bin/make -f
include ../common.mk

DI=debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test ! -f $(DI)/RECORD
	test ! -f $(DI)/direct_url.json
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control
	grep -q 'Depends:.*python3-importlib-metadata \| python3 (>> 3\.5)' debian/python3-foo/DEBIAN/control
	grep -L 'Depends:.*tox' debian/python3-foo/DEBIAN/control | grep -q control
	find .pybuild -name test-executed | grep -q test-executed
	grep -q usr/bin/python3$$ debian/python3-foo/usr/bin/foo
	find debian/python3-foo/usr/lib/python3/dist-packages/ -name LICENSE | { ! grep -q LICENSE; }

clean:
	./debian/rules clean

=== tests/tpb06/Makefile ===
#!/usr/bin/make -f
include ../common.mk

DI=debian/python3-foo/usr/lib/python3/dist-packages/foo-0.1.dist-info

check:
	test -f debian/python3-foo/usr/lib/python3/dist-packages/foo/__init__.py
	test ! -f $(DI)/RECORD
	test ! -f $(DI)/direct_url.json
	grep -q 'Depends:.*python3-cachy' debian/python3-foo/DEBIAN/control
	grep -q 'Depends:.*python3-importlib-metadata \| python3 (>> 3\.5)' debian/python3-foo/DEBIAN/control
	grep -L 'Depends:.*tox' debian/python3-foo/DEBIAN/control | grep -q control
	find .pybuild -name test-executed | grep -q test-executed
	grep -q usr/bin/python3$$ debian/python3-foo/usr/bin/foo
	find debian/python3-foo/usr/lib/python3/dist-packages/ -name LICENSE | { ! grep -q LICENSE; }
	test -f debian/python3-foo/usr/share/man/man1/foo.1.gz

clean:
	./debian/rules clean

=== tests/ta01/debian/changelog ===
foo (1.2.3) unstable; urgency=low

  * Initial release

 -- Piotr Ozarowski <piotr@debian.org>  Tue, 02 Jul 2013 11:02:06 +0200

=== debian/rules ===
#! /usr/bin/make -f

%:
	dh $@

clean:
	make clean
	dh_clean

override_dh_auto_test:
	make tests

override_dh_auto_install:
	DESTDIR=debian/dh-python PREFIX=/usr make install
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
	DESTDIR=debian/dh-python PREFIX=/usr make manpages
endif
	# generate maintainer scripts, etc.
	./dh_python3

=== tests/t301/debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=python_distutils

override_dh_auto_install:
	python3 setup.py install --root=debian/python3-foo/
	# Leave some coverage droppings
	mkdir -p debian/python3-foo/usr/lib/python3/dist-packages
	echo "abc" > debian/python3-foo/usr/lib/python3/dist-packages/.coverage

override_dh_install:
	dh_install
	find debian/ -name jquery.js -exec \
	ln -fs /usr/share/javascript/jquery/jquery.js '{}' \;
	DH_VERBOSE=1 ../../dh_python3\
		--depends 'SQLAlchemy >= 0.6.1'\
		--recommends Mako\
		--suggests 'Foo >= 0.1'\
		--suggests 'bar >= 1.0'

clean:
	rm -rf build Foo.egg-info
	dh clean

override_dh_auto_build:

override_dh_auto_clean:
	#python3 setup.py clean

=== tests/t304/debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --buildsystem=python_distutils

override_dh_auto_build:
override_dh_auto_install:

override_dh_install:
	dh_install
	DH_VERBOSE=1 ../../dh_python3 -p foo
	DH_VERBOSE=1 ../../dh_python3 -p foo /usr/share/bar -X spam.py
	DH_VERBOSE=1 ../../dh_python3 -p foo /usr/share/baz32 --shebang '/usr/bin/python3.2 -OO'

	# Argument priority: -O > regular args > DH_OPTIONS
	DH_VERBOSE=1 DH_OPTIONS=--shebang=/usr/bin/python3.0 \
		../../dh_python3 -p overrides \
		--shebang=/usr/bin/python3-dbg \
		/usr/share/overrides1
	DH_VERBOSE=1 ../../dh_python3 -p overrides \
		--shebang=/usr/bin/python3.0 \
		-O=--shebang=/usr/bin/python3-dbg \
		-O=--foo=bar \
		/usr/share/overrides2

clean:
	dh_clean

=== tests/ta01/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install

override_dh_auto_test:
	../../pybuild --test

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf .pybuild foo.egg-info

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

before-pybuild-autopkgtest:
	echo $(PYBUILD_AUTOPKGTEST) > marker-PYBUILD_AUTOPKGTEST
	touch marker-before-pybuild-autopkgtest

after-pybuild-autopkgtest:
	touch marker-after-pybuild-autopkgtest

=== tests/ta02/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo
export PYBUILD_TEST_CUSTOM=1
export PYBUILD_TEST_ARGS=touch {dir}/custom-test-executed

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install

override_dh_auto_test:
	../../pybuild --test

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf custom-test-executed foo.egg-info

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/ta03/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo
export PYBUILD_TEST_TOX=1

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install

override_dh_auto_test:
	../../pybuild --test

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf foo.egg-info .tox test-ran

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb01/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build

override_dh_auto_install:
	../../pybuild --install

override_dh_auto_test:
	../../pybuild --test

override_dh_auto_clean:
	../../pybuild --clean
	rm -rf .pybuild

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb04/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo
export PYBUILD_EXT_DESTDIR_python3=debian/python3-foo-ext

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build

override_dh_auto_install:
	../../pybuild --install

override_dh_auto_test:
	../../pybuild --test --test-tox --test-args=-v

override_dh_auto_clean:
	../../pybuild --clean
	rm -rf .pybuild .tox foo.egg-info test-executed

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb05/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install
	../../pybuild --install

override_dh_auto_test:
	../../pybuild --test --test-pytest

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf .pybuild

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb06/debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=foo

%:
	dh $@

override_dh_auto_build:
	../../pybuild --build --verbose

override_dh_auto_install:
	../../pybuild --install

override_dh_auto_test:
	../../pybuild --test

override_dh_auto_clean:
	../../pybuild --clean --verbose
	rm -rf .pybuild

override_dh_installinit:
	DH_VERBOSE=1 ../../dh_python3
	dh_installinit

override_dh_python3:
	# ignore any system dh_python3

=== tests/tpb07/debian/rules ===
--- 
+++ 
@@ -20,7 +20,7 @@
 override_dh_auto_clean:
 	../../pybuild -d foo --clean --verbose --name=foo
 	../../pybuild -d bar --clean --verbose --name=bar
-	rm -rf .pybuild foo/foo.egg-info bar/bar.egg-info foo/.tox foo/tests-executed-foo
+	rm -rf .pybuild foo/.tox foo/tests-executed-foo
 
 override_dh_installinit:
 	DH_VERBOSE=1 ../../dh_python3

=== tests/t302/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper (>= 7.0.50~), python3-all-dev
Standards-Version: 3.9.1
Rules-Requires-Root: no
X-Python3-Version: >= 3.2

Package: python3-foo
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Recommends: ${python3:Recommends}
Suggests: ${python3:Suggests}
Enhances: ${python3:Enhances}
Breaks: ${python3:Breaks}
Provides: ${python3:Provides}
Description: package with public and private Python 3 extension
 example package #3 - Python extensions

=== tests/t303/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper (>= 7.0.50~), python3-all-dev
Rules-Requires-Root: no
Standards-Version: 3.9.1

Package: python3-foo
Architecture: all
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public Python 3 modules
 example package #4 - fix_locations test

=== tests/t306/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Maximilian Engelhardt <maxi@daemonizer.de>
Build-Depends: debhelper (>= 12.9), python3-all-dev:any
Rules-Requires-Root: no
Standards-Version: 4.5.1

Package: foo
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with python3-all-dev dependency using :any
 example package #6 - private Python extensions and python3-all-dev:any
 dependency

=== tests/ta03/debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  , python3-pytest
  , python3-tox
  , python3-setuptools
+Rules-Requires-Root: no
 Standards-Version: 3.9.4
 
 Package: python3-foo

=== tests/tpb01/debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  , python3-setuptools
  , python3-cachy
 # , dh-python
+Rules-Requires-Root: no
 Standards-Version: 3.9.4
 
 Package: python3-foo

=== tests/tpb06/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , python3-all
 , python3-setuptools
 , pybuild-plugin-pyproject
Rules-Requires-Root: no
Standards-Version: 3.9.4

Package: python3-foo
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #1

=== tests/tpb07/debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
  , python3-setuptools
  , pybuild-plugin-pyproject
  , tox (>= 4)
+Rules-Requires-Root: no
 Standards-Version: 3.9.4
 
 Package: python3-foo

## dh-python 6.20240422

=== debian/changelog ===
dh-python (6.20240422) unstable; urgency=medium

  * Add support for Python 3.11 and 3.12 in test_interpreter.
  * Add generic test for the current default Python 3 interpreter in
    test_interpreter.
  * dh_python3: Don't rename _module to module. (Closes: #1068255)

 -- Stefano Rivera <stefanor@debian.org>  Mon, 22 Apr 2024 18:40:47 -0400

## dh-python 6.20240603

=== debian/changelog ===
dh-python (6.20240603) unstable; urgency=medium

  * Support dynamic versions in pdm.
  * Remove broken comment detection from pydist fallback generation script.
  * Update pydist data.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 03 Jul 2024 12:33:43 +0200

## dh-python 6.20240824

=== debian/changelog ===
dh-python (6.20240824) unstable; urgency=medium

  * pybuild: Drop support for setup.py test, now that setuptools 72 has
    removed it.  (Closes: #982298)
  * Bump Standards-Version to 4.7.0, no changes needed.
  * dh_python3: Improve documentation for -X / --exclude.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 24 Aug 2024 16:51:33 +0200

## dh-python 6.20241024

=== debian/changelog ===
dh-python (6.20241024) unstable; urgency=medium

  * dh_python3: Suppress generated dependencies that would be satisfied by
    python3 >= 3.9.
  * Run pybuild with --verbose in autopkgtests.
  * Don't trip over .coverage files. (Closes: #1081618)
  * Handle blank lines in .pyinstall and .pyremove, thanks Julian Gilbey.
    (Closes: #1075744)
  * Loosen exact Python version dependencies to accept Debian upload
    revisions. (Closes: #1083054)

 -- Stefano Rivera <stefanor@debian.org>  Thu, 24 Oct 2024 13:20:13 -0700

=== tests/t301/debian/rules ===
--- 
+++ 
@@ -6,7 +6,9 @@
 	python3 setup.py install --root=debian/python3-foo/
 	# Leave some coverage droppings
 	mkdir -p debian/python3-foo/usr/lib/python3/dist-packages
-	echo "abc" > debian/python3-foo/usr/lib/python3/dist-packages/.coverage
+	/usr/bin/printf '\xe2\x28\xa1' > debian/python3-foo/usr/lib/python3/dist-packages/.coverage
+	mkdir -p debian/python3-foo/usr/lib/$(shell py3versions -d)/dist-packages
+	/usr/bin/printf '\xe2\x82\x28' > debian/python3-foo/usr/lib/$(shell py3versions -d)/dist-packages/.coverage
 
 override_dh_install:
 	dh_install

## dh-python 6.20241024+exp1

=== debian/changelog ===
dh-python (6.20241024+exp1) experimental; urgency=medium

  * Upload to experimental with deprecated features disabled:
    - Drop the setuptools dependency.
  * Remove the previous patch, I don't think we'll land it as is:
    - pybuild: Stop ignoring an exit code of 5, for no tests found.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 24 Oct 2024 13:23:14 -0700

dh-python (6.20240905+exp1) experimental; urgency=medium

  * Upload to experimental with deprecated features disabled:
    - Drop the setuptools dependency.
    - pybuild: Stop ignoring an exit code of 5, for no tests found.
      (Closes: #1024971)

 -- Stefano Rivera <stefanor@debian.org>  Thu, 05 Sep 2024 18:51:19 +0200

## dh-python 6.20241217

=== debian/changelog ===
dh-python (6.20241217) unstable; urgency=medium

  * Document how to build multiple python modules in the same source package
    with --name in pybuild.1. (See: #1088676)
  * Don't pass dh_auto_install's default destdir to pybuild, allowing it to be
    overridden.
  * Remove test dependency on the debhelper python-distuils plugin.
    (Closes: #1090343)
  * Refresh pydist fallback data.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 17 Dec 2024 08:49:26 -0400

## dh-python 6.20250108

=== debian/changelog ===
dh-python (6.20250108) unstable; urgency=medium

  * Adjust CExtensionsRenameTest to always use the default Python 3 version.
    (Closes: #1092545)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 08 Jan 2025 17:27:01 -0400

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,7 @@
  python3-minimal,
  python3-nose2 <!nocheck>,
  python3-setuptools,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Git: https://salsa.debian.org/python-team/tools/dh-python.git
 Vcs-Browser: https://salsa.debian.org/python-team/tools/dh-python
 Rules-Requires-Root: no

## dh-python 6.20250308

=== tests/t304/Makefile ===
#!/usr/bin/make -f

include ../common.mk
clean: clean-common

check:
	# python3.2 hardcoded via `dh_python3 --shebang ...python3.2`
	grep -q '#! /usr/bin/python3.2 -OO' debian/foo/usr/share/baz32/baz.py
	# python3.4 hardcoded via shebang
	grep -q '/usr/share/foo \-V 3.4' debian/foo/DEBIAN/postinst
	# /env removed from shebang 
	grep -q '#! /usr/bin/python3' debian/foo/usr/share/bar/bar.py
	# /local removed from shebang 
	grep -q '#! /usr/bin/python3' debian/foo/usr/share/foo/baz.py
	grep -q '#! /usr/bin/python3.4' debian/foo/usr/share/foo/foo.py
	# make sure /usr/share/doc/ is ignored
	grep -q -v "py3compile -p foo /usr/share/doc"\
		debian/foo/DEBIAN/postinst
	# -X made it into the postinst
	grep -qF "/usr/share/bar -X 'spam.py'" debian/foo/DEBIAN/postinst
	# Check argument parsing order
	grep -q '#! /usr/bin/python3-dbg' debian/overrides/usr/share/overrides1/foo.py
	grep -q '#! /usr/bin/python3-dbg' debian/overrides/usr/share/overrides2/foo.py

=== tests/t306/Makefile ===
#!/usr/bin/make -f
include ../common.mk

all: run check

run: clean
	dpkg-buildpackage -b -us -uc

check:
	grep -qe "^Depends: .*python3\(:any\)\? (<< 3\.[0-9]\+)" \
		debian/foo/DEBIAN/control
	grep -qe "^Depends: .*python3\(:any\)\? (>= 3\.[0-9]\+~)" \
		debian/foo/DEBIAN/control

clean:
	./debian/rules clean
	rm -rf lib/Foo.egg-info build

=== debian/changelog ===
dh-python (6.20250308) unstable; urgency=medium

  * Exclude Pyside6 from cpython3_fallback, maintainers need to explicitly
    depend on the modules they require.

 -- Stefano Rivera <stefanor@debian.org>  Sat, 08 Mar 2025 09:00:48 -0400

dh-python (6.20250306) unstable; urgency=medium

  * Update pydist data.
  * Drop the python3-setuptools dependency.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 06 Mar 2025 10:54:33 -0400

=== tests/tpb07/debian/changelog ===
foobar (1.2.3) unstable; urgency=low

  * Initial release

 -- Piotr Ozarowski <piotr@debian.org>  Tue, 02 Jul 2013 11:02:06 +0200

=== debian/control ===
--- 
+++ 
@@ -24,8 +24,6 @@
 Architecture: all
 Multi-Arch: foreign
 Depends:
-# depend on setuptools to help packages migrate from distutils. Remove once 3.12 is default
- python3-setuptools,
  ${misc:Depends},
  ${python3:Depends},
 Provides:

=== tests/t304/debian/rules ===
--- 
+++ 
@@ -1,8 +1,9 @@
 #!/usr/bin/make -f
 %:
-	dh $@ --buildsystem=python_distutils
+	dh $@
 
 override_dh_auto_build:
+override_dh_auto_test:
 override_dh_auto_install:
 
 override_dh_install:

=== tests/t306/debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --buildsystem=none

override_dh_install:
	dh_install
	DH_VERBOSE=1 ../../dh_python3

override_dh_auto_build:
	python3 setup.py build

override_dh_auto_install:
	python3 setup.py install --root=debian/foo/ --install-lib=/usr/share/foo/python

override_dh_auto_clean:
	rm -rf build Foo.egg-info

=== tests/t304/debian/control ===
Source: foo
Section: misc
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper (>= 7.0.50~)
Build-Depends-Indep: python3
Rules-Requires-Root: no
Standards-Version: 3.9.3

Package: foo
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 4 - shebangs
 example package #4 - shebang related tests

Package: overrides
Architecture: all
Depends: ${python3:Depends}, ${misc:Depends}
Description: example 4 - command line parsing
 example package #4 - command line argument parsing

=== tests/ta01/debian/control ===
Source: foo
Section: python
Priority: optional
Maintainer: Piotr Ożarowski <piotr@debian.org>
Build-Depends: debhelper-compat (= 12)
 , pybuild-plugin-pyproject
 , python3-all
 , python3-setuptools
Rules-Requires-Root: no
Standards-Version: 3.9.4

Package: python3-foo
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Description: package with public CPython modules
 example package #8
